# coding: utf-8

"""
    Patch API V1

    The core API used to integrate with Patch's service  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: developers@usepatch.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from patch_api.configuration import Configuration


class Rec(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'allocated_energy_wh': 'int',
        'fulfilled_at': 'str',
        'fulfillment_state': 'str',
        'energy_wh': 'int',
        'price_cents_usd': 'str',
        'production': 'bool',
        'serial_number': 'str',
        'vintage_year': 'int',
        'project_id': 'str'
    }

    attribute_map = {
        'id': 'id',
        'allocated_energy_wh': 'allocated_energy_wh',
        'fulfilled_at': 'fulfilled_at',
        'fulfillment_state': 'fulfillment_state',
        'energy_wh': 'energy_wh',
        'price_cents_usd': 'price_cents_usd',
        'production': 'production',
        'serial_number': 'serial_number',
        'vintage_year': 'vintage_year',
        'project_id': 'project_id'
    }

    def __init__(self, id=None, allocated_energy_wh=None, fulfilled_at=None, fulfillment_state=None, energy_wh=None, price_cents_usd=None, production=None, serial_number=None, vintage_year=None, project_id=None, local_vars_configuration=None):  # noqa: E501
        """Rec - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._allocated_energy_wh = None
        self._fulfilled_at = None
        self._fulfillment_state = None
        self._energy_wh = None
        self._price_cents_usd = None
        self._production = None
        self._serial_number = None
        self._vintage_year = None
        self._project_id = None
        self.discriminator = None

        self.id = id
        self.allocated_energy_wh = allocated_energy_wh
        self.fulfilled_at = fulfilled_at
        self.fulfillment_state = fulfillment_state
        self.energy_wh = energy_wh
        self.price_cents_usd = price_cents_usd
        self.production = production
        self.serial_number = serial_number
        self.vintage_year = vintage_year
        self.project_id = project_id

    @property
    def id(self):
        """Gets the id of this Rec.  # noqa: E501

        A unique uid for the record. UIDs will be prepended by rec_prod or rec_test depending on the mode it was created in.  # noqa: E501

        :return: The id of this Rec.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Rec.

        A unique uid for the record. UIDs will be prepended by rec_prod or rec_test depending on the mode it was created in.  # noqa: E501

        :param id: The id of this Rec.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def allocated_energy_wh(self):
        """Gets the allocated_energy_wh of this Rec.  # noqa: E501

        The amount of energy in Wh already allocated from this REC.  # noqa: E501

        :return: The allocated_energy_wh of this Rec.  # noqa: E501
        :rtype: int
        """
        return self._allocated_energy_wh

    @allocated_energy_wh.setter
    def allocated_energy_wh(self, allocated_energy_wh):
        """Sets the allocated_energy_wh of this Rec.

        The amount of energy in Wh already allocated from this REC.  # noqa: E501

        :param allocated_energy_wh: The allocated_energy_wh of this Rec.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and allocated_energy_wh is None:  # noqa: E501
            raise ValueError("Invalid value for `allocated_energy_wh`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                allocated_energy_wh is not None and allocated_energy_wh > 1000000000):  # noqa: E501
            raise ValueError("Invalid value for `allocated_energy_wh`, must be a value less than or equal to `1000000000`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                allocated_energy_wh is not None and allocated_energy_wh < 0):  # noqa: E501
            raise ValueError("Invalid value for `allocated_energy_wh`, must be a value greater than or equal to `0`")  # noqa: E501

        self._allocated_energy_wh = allocated_energy_wh

    @property
    def fulfilled_at(self):
        """Gets the fulfilled_at of this Rec.  # noqa: E501

        The date in which the orders allocated to this REC were fulfilled.  # noqa: E501

        :return: The fulfilled_at of this Rec.  # noqa: E501
        :rtype: str
        """
        return self._fulfilled_at

    @fulfilled_at.setter
    def fulfilled_at(self, fulfilled_at):
        """Sets the fulfilled_at of this Rec.

        The date in which the orders allocated to this REC were fulfilled.  # noqa: E501

        :param fulfilled_at: The fulfilled_at of this Rec.  # noqa: E501
        :type: str
        """

        self._fulfilled_at = fulfilled_at

    @property
    def fulfillment_state(self):
        """Gets the fulfillment_state of this Rec.  # noqa: E501

        The current fulfillment state of the REC.  # noqa: E501

        :return: The fulfillment_state of this Rec.  # noqa: E501
        :rtype: str
        """
        return self._fulfillment_state

    @fulfillment_state.setter
    def fulfillment_state(self, fulfillment_state):
        """Sets the fulfillment_state of this Rec.

        The current fulfillment state of the REC.  # noqa: E501

        :param fulfillment_state: The fulfillment_state of this Rec.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and fulfillment_state is None:  # noqa: E501
            raise ValueError("Invalid value for `fulfillment_state`, must not be `None`")  # noqa: E501
        allowed_values = ["pending", "eligible", "approved", "fulfilled"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and fulfillment_state not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `fulfillment_state` ({0}), must be one of {1}"  # noqa: E501
                .format(fulfillment_state, allowed_values)
            )

        self._fulfillment_state = fulfillment_state

    @property
    def energy_wh(self):
        """Gets the energy_wh of this Rec.  # noqa: E501

        The amount of energy in Wh produced for this REC.  # noqa: E501

        :return: The energy_wh of this Rec.  # noqa: E501
        :rtype: int
        """
        return self._energy_wh

    @energy_wh.setter
    def energy_wh(self, energy_wh):
        """Sets the energy_wh of this Rec.

        The amount of energy in Wh produced for this REC.  # noqa: E501

        :param energy_wh: The energy_wh of this Rec.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and energy_wh is None:  # noqa: E501
            raise ValueError("Invalid value for `energy_wh`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                energy_wh is not None and energy_wh > 1000000000):  # noqa: E501
            raise ValueError("Invalid value for `energy_wh`, must be a value less than or equal to `1000000000`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                energy_wh is not None and energy_wh < 0):  # noqa: E501
            raise ValueError("Invalid value for `energy_wh`, must be a value greater than or equal to `0`")  # noqa: E501

        self._energy_wh = energy_wh

    @property
    def price_cents_usd(self):
        """Gets the price_cents_usd of this Rec.  # noqa: E501

        The total price in cents USD of this REC.  # noqa: E501

        :return: The price_cents_usd of this Rec.  # noqa: E501
        :rtype: str
        """
        return self._price_cents_usd

    @price_cents_usd.setter
    def price_cents_usd(self, price_cents_usd):
        """Sets the price_cents_usd of this Rec.

        The total price in cents USD of this REC.  # noqa: E501

        :param price_cents_usd: The price_cents_usd of this Rec.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and price_cents_usd is None:  # noqa: E501
            raise ValueError("Invalid value for `price_cents_usd`, must not be `None`")  # noqa: E501

        self._price_cents_usd = price_cents_usd

    @property
    def production(self):
        """Gets the production of this Rec.  # noqa: E501

        A boolean indicating if this REC is a production or test mode REC.  # noqa: E501

        :return: The production of this Rec.  # noqa: E501
        :rtype: bool
        """
        return self._production

    @production.setter
    def production(self, production):
        """Sets the production of this Rec.

        A boolean indicating if this REC is a production or test mode REC.  # noqa: E501

        :param production: The production of this Rec.  # noqa: E501
        :type: bool
        """
        if self.local_vars_configuration.client_side_validation and production is None:  # noqa: E501
            raise ValueError("Invalid value for `production`, must not be `None`")  # noqa: E501

        self._production = production

    @property
    def serial_number(self):
        """Gets the serial_number of this Rec.  # noqa: E501

        The serial number for this offset.  # noqa: E501

        :return: The serial_number of this Rec.  # noqa: E501
        :rtype: str
        """
        return self._serial_number

    @serial_number.setter
    def serial_number(self, serial_number):
        """Sets the serial_number of this Rec.

        The serial number for this offset.  # noqa: E501

        :param serial_number: The serial_number of this Rec.  # noqa: E501
        :type: str
        """

        self._serial_number = serial_number

    @property
    def vintage_year(self):
        """Gets the vintage_year of this Rec.  # noqa: E501


        :return: The vintage_year of this Rec.  # noqa: E501
        :rtype: int
        """
        return self._vintage_year

    @vintage_year.setter
    def vintage_year(self, vintage_year):
        """Sets the vintage_year of this Rec.


        :param vintage_year: The vintage_year of this Rec.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and vintage_year is None:  # noqa: E501
            raise ValueError("Invalid value for `vintage_year`, must not be `None`")  # noqa: E501

        self._vintage_year = vintage_year

    @property
    def project_id(self):
        """Gets the project_id of this Rec.  # noqa: E501


        :return: The project_id of this Rec.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this Rec.


        :param project_id: The project_id of this Rec.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and project_id is None:  # noqa: E501
            raise ValueError("Invalid value for `project_id`, must not be `None`")  # noqa: E501

        self._project_id = project_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Rec):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Rec):
            return True

        return self.to_dict() != other.to_dict()
